#!/usr/bin/python
# -*- coding: utf-8 -*-

#bumping balls in 3D
#Copyright (C) 2009  Janosch Maier <janosch_maier@online.de>
#For further information see <http://phylu.bplaced.de>

#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.


from Tkinter import * # Bibliothek für die grafische Oberfläche
                         
## Klasse für das Grafische Eingabefenster ##                              
class Application(Frame):
    def __init__(self, var, master=None): # Variablen Übergeben
        self.r = var[0]
        self.m = var[1]
        self.rx = var[2]
        self.ry = var[3]
        self.rz = var[4]
        self.vx = var[5]
        self.vy = var[6]
        self.vz = var[7]
        self.red = var[8]
        self.green = var[9]
        self.blue = var[10]
        self.color = [self.red, self.green, self.blue]
                                       
        Frame.__init__(self, master) # Fenster initiieren                    
        self.grid() # Fenster platzieren
        self.createWidgets() # Funktion zum füllen des FEnsters aufrufen
        
    def createWidgets(self): # Textlabels + Eingabefelder erstellen

        self.rLabel = Label(self, text="Radius") 
        self.rLabel.grid(row=0, column=0)
        self.rEntry = Entry(self, width=10)
        self.rEntry.insert(1, self.r) 
        self.rEntry.grid(row=0, column=1)
        
        self.mLabel = Label(self, text="Masse")
        self.mLabel.grid(row=1, column=0)
        self.mEntry = Entry(self, width=10)
        self.mEntry.insert (1, self.m) 
        self.mEntry.grid(row=1, column=1)
        
        self.rxLabel = Label(self, text="Ort X-Richtung")
        self.rxLabel.grid(row=2, column=0)
        self.rxEntry = Entry(self, width=10)
        self.rxEntry.insert (1, self.rx)
        self.rxEntry.grid(row=2, column=1)
        
        self.ryLabel = Label(self, text="Ort Y-Richtung")
        self.ryLabel.grid(row=3, column=0)
        self.ryEntry = Entry(self, width=10)
        self.ryEntry.insert (1, self.ry)
        self.ryEntry.grid(row=3, column=1)

        self.rzLabel = Label(self, text="Ort Z-Richtung")
        self.rzLabel.grid(row=4, column=0)
        self.rzEntry = Entry(self, width=10)
        self.rzEntry.insert (1, self.rz)
        self.rzEntry.grid(row=4, column=1)
        
        self.vxLabel = Label(self, text="Geschwindigkeit X-Richtung")
        self.vxLabel.grid(row=5, column=0)
        self.vxEntry = Entry(self, width=10)
        self.vxEntry.insert (1, self.vx)
        self.vxEntry.grid(row=5, column=1)

        self.vyLabel = Label(self, text="Geschwindigkeit Y-Richtung")
        self.vyLabel.grid(row=6, column=0)
        self.vyEntry = Entry(self, width=10)
        self.vyEntry.insert (1, self.vy)
        self.vyEntry.grid(row=6, column=1)

        self.vzLabel = Label(self, text="Geschwindigkeit Z-Richtung")
        self.vzLabel.grid(row=7, column=0)
        self.vzEntry = Entry(self, width=10)
        self.vzEntry.insert (1, self.vz)
        self.vzEntry.grid(row=7, column=1)

        self.radio = IntVar() # Variablen für die Radiobuttonliste setzen
        self.colorButton = [0, 1, 2, 3, 4, 5, 6]

        self.colorLabel = Label(self, text="Farbe") # Textlabel Farbe + Radiobuttons erstellen
        self.colorLabel.grid(row=8, column=0)
        self.colorButton[0] = Radiobutton(self, text="weiß", variable=self.radio, value=0)
        self.colorButton[0].grid(row=8, column=1)
        self.colorButton[1] = Radiobutton(self, text="rot", variable=self.radio, value=1)
        self.colorButton[1].grid(row=9, column=0)
        self.colorButton[2] = Radiobutton(self, text="grün", variable=self.radio, value=2)
        self.colorButton[2].grid(row=9, column=1)
        self.colorButton[3] = Radiobutton(self, text="blau", variable=self.radio, value=3)
        self.colorButton[3].grid(row=10, column=0)
        self.colorButton[4] = Radiobutton(self, text="gelb", variable=self.radio, value=4)
        self.colorButton[4].grid(row=10, column=1)
        self.colorButton[5] = Radiobutton(self, text="magenta", variable=self.radio, value=5)
        self.colorButton[5].grid(row=11, column=0)
        self.colorButton[6] = Radiobutton(self, text="cyan", variable=self.radio, value=6)
        self.colorButton[6].grid(row=11, column=1)
 
        if self.color == [1.0, 1.0, 1.0]: # Den Radiobutton mit der richtigen Farbe aktivieren
            self.colorButton[0].select()
        elif self.color == [1.0, 0.0, 0.0]:
            self.colorButton[1].select()
        elif self.color == [0.0, 1.0, 0.0]:
            self.colorButton[2].select()
        elif self.color == [0.0, 0.0, 1.0]:
            self.colorButton[3].select()
        elif self.color == [1.0, 1.0, 0.0]:
            self.colorButton[4].select()
        elif self.color == [1.0, 0.0, 1.0]:
            self.colorButton[5].select()
        elif self.color == [0.0, 1.0, 1.0]:
            self.colorButton[6].select()
        
        self.submitButton = Button(self, text="Eingabe", command=self.newVars) # Eingabe Button bauen
        self.submitButton.grid() # und platzieren

    def newVars(self): # Funktion zum übergeben der Variablen
        self.r = self.rEntry.get() # Variablen uebergeben
        self.m = self.mEntry.get()
        self.rx = self.rxEntry.get()
        self.ry = self.ryEntry.get()
        self.rz = self.rzEntry.get()
        self.vx = self.vxEntry.get()
        self.vy = self.vyEntry.get()
        self.vz = self.vzEntry.get()
        self.colorVar = self.radio.get() # Farbe in rgb umwandeln
        if self.colorVar == 0:
            self.color = [1.0, 1.0, 1.0]
        elif self.colorVar == 1:
            self.color = [1.0, 0.0, 0.0]
        elif self.colorVar == 2:
            self.color = [0.0, 1.0, 0.0]
        elif self.colorVar == 3:
            self.color = [0.0, 0.0, 1.0]
        elif self.colorVar == 4:
            self.color = [1.0, 1.0, 0.0]
        elif self.colorVar == 5:
            self.color = [1.0, 0.0, 1.0]
        elif self.colorVar == 6:
            self.color = [0.0, 1.0, 1.0]
        if self.color:
            self.red = self.color[0]
            self.green = self.color[1]
            self.blue = self.color[2]
            
        self.master.destroy()
        self.quit()
        
    def getVars(self): # Funktion zum Übergeben der Variablen
        return [float(self.r), float(self.m), float(self.rx), float(self.ry), float(self.rz), float(self.vx), float(self.vy), float(self.vz), float(self.red), float(self.green), float(self.blue)]
